SystemOrganization addCategory: #'Orange-Xtreams'!

PEGActor subclass: #PEGArithmeticEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Xtreams'!

!PEGArithmeticEvaluator methodsFor: 'as yet unclassified' stamp: 'chc 7/27/2015 16:09'!
Number: digits
                <action: 'Number'>
                ^digits inject: 0 into: [ :total :digit | total * 10 + ('0123456789' indexOf: digit) - 1 ]! !

!PEGArithmeticEvaluator methodsFor: 'as yet unclassified' stamp: 'chc 7/27/2015 16:36'!
Parenthesised: expression
        <action: 'Parenthesised' arguments: #(2)>
        ^expression! !

!PEGArithmeticEvaluator methodsFor: 'as yet unclassified' stamp: 'chc 7/27/2015 16:27'!
Product: first rest: pairs
                <action: 'Product' arguments: #(1 2)>
                ^pairs inject: first into: [ :total :pair |
                        (pair first = '*')
                                ifTrue: [ total * pair last ]
                                ifFalse: [ total / pair last ] ]! !

!PEGArithmeticEvaluator methodsFor: 'as yet unclassified' stamp: 'chc 7/27/2015 16:33'!
Sum: first rest: pairs
                <action: 'Sum' arguments: #(1 2)>
                ^pairs inject: first into: [ :total :pair |
                        (pair first = '+')
                                ifTrue: [ total + pair last ]
                                ifFalse: [ total - pair last ] ]! !

PEGActor subclass: #PEGWikiGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Xtreams'!

!PEGWikiGenerator methodsFor: 'lexical' stamp: 'chc 8/20/2015 18:08'!
Bold: flow
	<action: 'Bold' arguments: #( 2 )>
	^'<b>' , (self doGenerate: flow) , '</b>'! !

!PEGWikiGenerator methodsFor: 'lexical' stamp: 'chc 7/28/2015 16:11'!
Code: flow
	<action: 'Code' arguments: #( 2 )>
	^'<pre>' , (self doGenerate: flow) , '</pre>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/28/2015 15:42'!
Heading1: flow
	<action: 'Heading1' arguments: #(3) >
	^'<h1>' , (self doGenerate: flow) , '</h1>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/28/2015 15:43'!
Heading2: flow
	<action: 'Heading2' arguments: #(3) >
	^'<h2>' , (self doGenerate: flow) , '</h2>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/15/2015 14:00'!
Heading3: flow
	<action: 'Heading3' arguments: #(3) >
	^'<h3>' , (self doGenerate: flow) , '</h3>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/28/2015 15:44'!
Heading4: flow
	<action: 'Heading4' arguments: #(3) >
	^'<h4>' , (self doGenerate: flow) , '</h4>'! !

!PEGWikiGenerator methodsFor: 'lexical' stamp: 'chc 8/20/2015 18:08'!
Italic: flow
	<action: 'Italic' arguments: #( 2 )>
	^'<i>' , (self doGenerate: flow)  ,  '</i>'! !

!PEGWikiGenerator methodsFor: 'lexical' stamp: 'chc 7/15/2015 22:31'!
Link: flow
	<action: 'LinkShort' arguments: #( 2 )>
	| linkContent |
	linkContent := self doGenerate: flow.
	^'<a href="http://www.' , linkContent , '.com">' , linkContent , '</a>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 10/26/2015 09:54'!
ListItem: bullets flow: flow
	<action: 'Bullet1' arguments: #(2 3)>
	^'<li>' , (self doGenerate: flow) , '</li>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/14/2015 14:29'!
Page: lines
	<action: 'Page'>
	^'<div>' , (self doGenerate: lines) , '</div>'! !

!PEGWikiGenerator methodsFor: 'structural' stamp: 'chc 7/14/2015 14:29'!
Paragraph: flow
	<action: 'Paragraph'>
	^'<p>' , (self doGenerate: flow) , '</p>'! !

!PEGWikiGenerator methodsFor: 'private' stamp: 'chc 7/14/2015 14:35'!
doGenerate: flow
	| alltogether |
	alltogether := String new writing.
	flow do: [:ea| alltogether write: ea].
	^alltogether conclusion! !
